﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Data;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.MetaOptimization {
  public class DoubleValueRange : Range<DoubleValue> {

    public DoubleValueRange(DoubleValue lowerBound, DoubleValue upperBound, DoubleValue stepSize) : base(lowerBound, upperBound, stepSize) { }
    public DoubleValueRange() { }
    protected DoubleValueRange(DoubleValueRange original, Cloner cloner) : base(original, cloner) { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new DoubleValueRange(this, cloner);
    }

    public override DoubleValue GetRandomValue() {
      Random rand = new Random(); // todo: use common random
      double val;
      do {
        val = Math.Round((rand.NextDouble() * (UpperBound.Value - LowerBound.Value) + LowerBound.Value) / StepSize.Value, 0) * StepSize.Value;
      } while (val < LowerBound.Value || val > UpperBound.Value);
      return new DoubleValue(val);
    }
  }
}
