﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Data;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.MetaOptimization {
  public class IntValueRange : Range<IntValue> {

    public IntValueRange(IntValue lowerBound, IntValue upperBound, IntValue stepSize) : base(lowerBound, upperBound, stepSize) { }
    public IntValueRange() { }
    protected IntValueRange(IntValueRange original, Cloner cloner) : base(original, cloner) { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntValueRange(this, cloner);
    }

    public override IntValue GetRandomValue() {
      Random rand = new Random(); // todo: use common random
      int val;
      do {
        val = rand.Next(LowerBound.Value / StepSize.Value, UpperBound.Value / StepSize.Value + 1) * StepSize.Value;
      } while (val < LowerBound.Value || val > UpperBound.Value);
      return new IntValue(val);
    }
  }
}
