﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Data;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.MetaOptimization {
  public class PercentValueRange : Range<PercentValue> {

    public PercentValueRange(PercentValue lowerBound, PercentValue upperBound, PercentValue stepSize) : base(lowerBound, upperBound, stepSize) { }
    public PercentValueRange() { }
    protected PercentValueRange(PercentValueRange original, Cloner cloner) : base(original, cloner) { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PercentValueRange(this, cloner);
    }

    public override PercentValue GetRandomValue() {
      Random rand = new Random(); // todo: use common random
      double val;
      do {
        val = Math.Round((rand.NextDouble() * (UpperBound.Value - LowerBound.Value) + LowerBound.Value) / StepSize.Value, 0) * StepSize.Value;
      } while (val < LowerBound.Value || val > UpperBound.Value);
      return new PercentValue(val);
    }
  }
}
