﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.MetaOptimization {
  public interface IOptimizable : IItem {
    bool IsOptimizable { get; }
    bool Optimize { get; set; }
    ConstrainedValue ActualValue { get; set; }

    void Parameterize();
    void Randomize();
    void Mutate();
    void Cross(IOptimizable other);

    event EventHandler IsOptimizableChanged;
    event EventHandler OptimizeChanged;
  }
}
